single format

This commit is contained in:
Luke Smith 2019-09-21 14:23:08 -04:00
parent 121311dd4a
commit a84320279a
No known key found for this signature in database
GPG Key ID: 4C50B54A911F6252
4 changed files with 25 additions and 240 deletions

View File

@ -6,19 +6,17 @@
### OPTIONS AND VARIABLES ###
while getopts ":a:r:b:p:h" o; do case "${o}" in
h) printf "Optional arguments for custom use:\\n -r: Dotfiles repository (local file or url)\\n -b: Dotfiles branch (master is assumed otherwise)\\n -p: Dependencies and programs csv (local file or url)\\n -a: AUR helper (must have pacman-like syntax)\\n -h: Show this message\\n" && exit ;;
h) printf "Optional arguments for custom use:\\n -r: Dotfiles repository (local file or url)\\n -p: Dependencies and programs csv (local file or url)\\n -a: AUR helper (must have pacman-like syntax)\\n -h: Show this message\\n" && exit ;;
r) dotfilesrepo=${OPTARG} && git ls-remote "$dotfilesrepo" || exit ;;
b) repobranch=${OPTARG} ;;
p) progsfile=${OPTARG} ;;
a) aurhelper=${OPTARG} ;;
*) printf "Invalid option: -%s\\n" "$OPTARG" && exit ;;
esac done
# DEFAULTS:
[ -z "$dotfilesrepo" ] && dotfilesrepo="https://github.com/lukesmithxyz/voidrice.git" && repobranch="archi3"
[ -z "$dotfilesrepo" ] && dotfilesrepo="https://github.com/lukesmithxyz/voidrice.git"
[ -z "$progsfile" ] && progsfile="https://raw.githubusercontent.com/LukeSmithxyz/LARBS/master/archi3/progs.csv"
[ -z "$aurhelper" ] && aurhelper="yay"
[ -z "$repobranch" ] && repobranch="master"
### FUNCTIONS ###
@ -122,28 +120,27 @@ installationloop() { \
putgitrepo() { # Downlods a gitrepo $1 and places the files in $2 only overwriting conflicts
dialog --infobox "Downloading and installing config files..." 4 60
[ -z "$3" ] && branch="master" || branch="$repobranch"
dir=$(mktemp -d)
[ ! -d "$2" ] && mkdir -p "$2" && chown -R "$name:wheel" "$2"
chown -R "$name:wheel" "$dir"
sudo -u "$name" git clone -b "$branch" --depth 1 "$1" "$dir/gitrepo" >/dev/null 2>&1 &&
sudo -u "$name" git clone --depth 1 "$1" "$dir/gitrepo" >/dev/null 2>&1 &&
sudo -u "$name" cp -rfT "$dir/gitrepo" "$2"
}
serviceinit() { for service in "$@"; do
case "$(readlink /sbin/init)" in
runit*) serviceinit(){ ln -s "/etc/runit/sv/$1" /run/runit/service; sv restart "$1" ;} ;;
*) serviceinit(){ systemctl enable "$1"; systemctl start "$1" ;} ;;
esac
serviceinitwrap() { for service in "$@"; do
dialog --infobox "Enabling \"$service\"..." 4 40
systemctl enable "$service"
systemctl start "$service"
serviceinit "$service"
done ;}
systembeepoff() { dialog --infobox "Getting rid of that retarded error beep sound..." 10 50
rmmod pcspkr
echo "blacklist pcspkr" > /etc/modprobe.d/nobeep.conf ;}
resetpulse() { dialog --infobox "Reseting Pulseaudio..." 4 50
killall pulseaudio
sudo -n "$name" pulseaudio --start ;}
finalize(){ \
dialog --infobox "Preparing welcome message..." 4 50
echo "exec_always --no-startup-id notify-send -i ~/.local/share/larbs/larbs.png 'Welcome to LARBS:' 'Press Super+F1 for the manual.' -t 10000" >> "/home/$name/.config/i3/config"
@ -200,17 +197,14 @@ manualinstall $aurhelper || error "Failed to install AUR helper."
installationloop
# Install the dotfiles in the user's home directory
putgitrepo "$dotfilesrepo" "/home/$name" "$repobranch"
putgitrepo "$dotfilesrepo" "/home/$name"
rm -f "/home/$name/README.md" "/home/$name/LICENSE"
# Install the LARBS Firefox profile in ~/.mozilla/firefox/
putgitrepo "https://github.com/LukeSmithxyz/mozillarbs.git" "/home/$name/.mozilla/firefox"
# Pulseaudio, if/when initially installed, often needs a restart to work immediately.
[ -f /usr/bin/pulseaudio ] && resetpulse
# Enable services here.
serviceinit NetworkManager cronie
serviceinitwrap NetworkManager cronie
# Most important command! Get rid of the beep!
systembeepoff
@ -220,6 +214,11 @@ systembeepoff
newperms "%wheel ALL=(ALL) ALL #LARBS
%wheel ALL=(ALL) NOPASSWD: /usr/bin/shutdown,/usr/bin/reboot,/usr/bin/systemctl suspend,/usr/bin/wifi-menu,/usr/bin/mount,/usr/bin/umount,/usr/bin/pacman -Syu,/usr/bin/pacman -Syyu,/usr/bin/packer -Syu,/usr/bin/packer -Syyu,/usr/bin/systemctl restart NetworkManager,/usr/bin/rc-service NetworkManager restart,/usr/bin/pacman -Syyu --noconfirm,/usr/bin/loadkeys,/usr/bin/yay,/usr/bin/pacman -Syyuw --noconfirm"
# Make zsh the default shell for the user
sed "s/^$name:\(.*\):\/bin\/.*/$name:\1:\/bin\/zsh/" /etc/passwd
# dbus-uuidgen > /var/lib/dbus/machine-id
# Last message! Install complete!
finalize
clear

View File

@ -1,14 +1,12 @@
#TAG,NAME IN REPO (or git url),PURPOSE (should be a verb phrase to sound right while installing)
,i3-gaps,"is the main graphical user interface and window manager."
,xorg-server,"is the graphical server."
,xorg-xwininfo,"allows querying information about windows."
,xorg-xinit,"starts the graphical server."
,sxhkd,"binds key."
,sxhkd,"binds keys."
,ttf-inconsolata,"is the monospace font of LARBS."
,ttf-linux-libertine,"provides the sans and serif fonts for LARBS."
,vifm,"is an extensive terminal file manager that everyone likes."
,ed,"is the standard editor!"
,tree,"lists directory contents like trees. Used by vifm."
,lf,"is an extensive terminal file manager that everyone likes."
,arandr,"is a UI for screen adjustment."
,bc,"is used for a dropdown calculator."
,calcurse,"is a lightweight terminal-based calendar."
@ -24,21 +22,18 @@
,gnome-keyring,"serves as the system keyring."
A,gtk-theme-arc-gruvbox-git,"gives the dark GTK theme used in LARBS."
,neovim,"an tidier vim with some useful features"
,i3blocks,"is the status bar."
,i3lock,"is the screen lock."
,mpd,"is a lightweight music daemon."
,mpc,"is a terminal interface for mpd."
,mpv,"is the patrician's choice video player."
,ncmpcpp,"a ncurses interface for music with multiple formats and a powerful tag editor."
,networkmanager,"does exactly what it sounds like."
,networkmanager-runit,"does exactly what it sounds like."
,newsboat,"is a terminal RSS client."
,firefox,"is the only program on LARBS your girlfriend has ever heard of."
,brave,"is an elegant browser with built-in adblocking, tor and other features."
A,ttf-emojione,"is a package that gives the system unicode symbols and emojis used in the status bar and elsewhere."
A,ttf-symbola,"provides unicode and emoji symbols."
,ntfs-3g,"allows accessing NTFS partitions."
,pulseaudio,"is the audio system (>inb4 bloat)."
,pulseaudio-alsa,"is an audio interface with ALSA."
,pulsemixer,"is an intuitive ncurses audio controller."
,alsa-utils,"is an audio interface for ALSA."
,imagemagick,"is a terminal image-manipulator providing some convenient shortcuts and the lockscreen in LARBS."
A,sc-im,"is an Excel-like terminal spreadsheet manager."
A,htop-vim-git,"provides system usage information and displays processes."
@ -60,14 +55,14 @@ A,urlscan,"parses URLs in the terminal allowing keyboard-based selection."
,zathura-pdf-mupdf,"allows mupdf pdf compatibility in zathura."
A,python-ueberzug,"generates image previews in vifm and other terminal programs."
,poppler,"manipulates .pdfs and gives .pdf previews and other .pdf functions."
,mediainfo,"shows audio and video information and is used by vifm as well."
,mediainfo,"shows audio and video information and is used by lf as well."
,atool,"manages and gives information about archives."
,fzf,"is a fuzzy finder tool."
,highlight,"can highlight code output."
,xorg-xbacklight,"enables changing screen brightness levels."
,zsh-syntax-highlighting,"provides fish-like syntax highlighting in the shell."
A,task-spooler,"queues commands or files for download."
A,simple-mtpfs,"enables the mounting of cell phones."
G,https://github.com/lukesmithxyz/dmenu.git,"runs commands and provides a UI for selection."
G,https://github.com/lukesmithxyz/st.git,"is my custom build of suckless's terminal emulator."
,docx2txt,"enables .docx file previews in vifm."
,odt2txt,"enables .odt file previews in vifm."
G,https://github.com/lukesmithxyz/dwm.git,"is the window manager."
1 #TAG NAME IN REPO (or git url) PURPOSE (should be a verb phrase to sound right while installing)
i3-gaps is the main graphical user interface and window manager.
2 xorg-server is the graphical server.
3 xorg-xwininfo allows querying information about windows.
4 xorg-xinit starts the graphical server.
5 sxhkd binds key. binds keys.
6 ttf-inconsolata is the monospace font of LARBS.
7 ttf-linux-libertine provides the sans and serif fonts for LARBS.
vifm is an extensive terminal file manager that everyone likes.
8 ed is the standard editor!
9 tree lf lists directory contents like trees. Used by vifm. is an extensive terminal file manager that everyone likes.
10 arandr is a UI for screen adjustment.
11 bc is used for a dropdown calculator.
12 calcurse is a lightweight terminal-based calendar.
22 gnome-keyring serves as the system keyring.
23 A gtk-theme-arc-gruvbox-git gives the dark GTK theme used in LARBS.
24 neovim an tidier vim with some useful features
i3blocks is the status bar.
i3lock is the screen lock.
25 mpd is a lightweight music daemon.
26 mpc is a terminal interface for mpd.
27 mpv is the patrician's choice video player.
28 ncmpcpp a ncurses interface for music with multiple formats and a powerful tag editor.
29 networkmanager does exactly what it sounds like.
30 networkmanager-runit does exactly what it sounds like.
31 newsboat is a terminal RSS client.
32 firefox brave is the only program on LARBS your girlfriend has ever heard of. is an elegant browser with built-in adblocking, tor and other features.
33 A ttf-emojione is a package that gives the system unicode symbols and emojis used in the status bar and elsewhere.
34 A ttf-symbola provides unicode and emoji symbols.
35 ntfs-3g allows accessing NTFS partitions.
36 pulseaudio alsa-utils is the audio system (>inb4 bloat). is an audio interface for ALSA.
pulseaudio-alsa is an audio interface with ALSA.
pulsemixer is an intuitive ncurses audio controller.
37 imagemagick is a terminal image-manipulator providing some convenient shortcuts and the lockscreen in LARBS.
38 A sc-im is an Excel-like terminal spreadsheet manager.
39 A htop-vim-git provides system usage information and displays processes.
55 zathura-pdf-mupdf allows mupdf pdf compatibility in zathura.
56 A python-ueberzug generates image previews in vifm and other terminal programs.
57 poppler manipulates .pdfs and gives .pdf previews and other .pdf functions.
58 mediainfo shows audio and video information and is used by vifm as well. shows audio and video information and is used by lf as well.
59 atool manages and gives information about archives.
60 fzf is a fuzzy finder tool.
61 highlight can highlight code output.
62 xorg-xbacklight enables changing screen brightness levels.
63 zsh-syntax-highlighting provides fish-like syntax highlighting in the shell.
64 A task-spooler queues commands or files for download.
65 A simple-mtpfs enables the mounting of cell phones.
66 G https://github.com/lukesmithxyz/dmenu.git runs commands and provides a UI for selection.
67 G https://github.com/lukesmithxyz/st.git is my custom build of suckless's terminal emulator.
68 G docx2txt https://github.com/lukesmithxyz/dwm.git enables .docx file previews in vifm. is the window manager.
odt2txt enables .odt file previews in vifm.

View File

@ -1,140 +0,0 @@
#!/bin/sh
# Luke's Auto Rice Boostrapping Script (LARBS)
# by Luke Smith <luke@lukesmith.xyz>
# License: GNU GPLv3
### OPTIONS AND VARIABLES ###
while getopts ":r:p:b:h" o; do case "${o}" in
h) printf "Optional arguments for custom use:\\n -r: Dotfiles repository (local file or url)\\n -b: Dotfiles branch (master is assumed otherwise)\\n -p: Dependencies and programs csv (local file or url)\\n -h: Show this message\\n" && exit ;;
r) dotfilesrepo=${OPTARG} && git ls-remote "$dotfilesrepo" || exit ;;
b) repobranch=${OPTARG} ;;
p) progsfile=${OPTARG} ;;
*) printf "Invalid option: -%s\\n" "$OPTARG" && exit ;;
esac done
# DEFAULTS:
[ -z "$dotfilesrepo" ] && dotfilesrepo="https://github.com/lukesmithxyz/voidrice.git" && repobranch="voiddwm"
[ -z "$progsfile" ] && progsfile="https://raw.githubusercontent.com/LukeSmithxyz/LARBS/master/voiddwm/vprogs.csv"
[ -z "$repobranch" ] && repobranch="master"
### FUNCTIONS ###
error() { clear; printf "ERROR:\\n%s\\n" "$1"; exit;}
welcomemsg() { \
dialog --title "Welcome!" --msgbox "Welcome to Luke's Auto-Rice Bootstrapping Script!\\n\\nThis script will automatically install a fully-featured i3wm Void Linux desktop, which I use as my main machine.\\n\\n-Luke" 10 60
}
getuser() { \
name=$(dialog --inputbox "First, please enter a name for the user account for which you'd like to install LARBS." 10 60 3>&1 1>&2 2>&3 3>&1) || exit
while ! echo "$name" | grep "^[a-z_][a-z0-9_-]*$" >/dev/null 2>&1; do
name=$(dialog --no-cancel --inputbox "Username not valid. Give a username beginning with a letter, with only lowercase letters, - or _." 10 60 3>&1 1>&2 2>&3 3>&1)
done
! (id -u "$name" >/dev/null) 2>&1 &&
dialog --title "Create user first then re-run script" --msgbox "Please create your user and password before running LARBS. Note that you can use the user you created in the Void Linux installation process.\\n\\nIf you want to make a new user, you will want to run a command like this, adding your user to all the needed groups and creating a home directory:\\n\\n$ useradd -m -G wheel,users,audio,video,cdrom,input -s /bin/bash <user>\\n$ passwd <user>" 14 75 && exit
return 0 ;}
preinstallmsg() { \
dialog --title "Let's get this party started!" --yes-label "Let's go!" --no-label "No, nevermind!" --yesno "The rest of the installation will now be totally automated, so you can sit back and relax.\\n\\nIt will take some time, but when done, you can relax even more with your complete system.\\n\\nNow just press <Let's go!> and the system will begin installation!" 13 60 || { clear; exit; }
}
maininstall() { # Installs all needed programs from main repo.
dialog --title "LARBS Installation" --infobox "Installing \`$1\` ($n of $total). $1 $2" 5 70
xbps-install -y "$1" >/dev/null 2>&1
}
gitmakeinstall() {
repo="$(basename "$1")"
repodir="/home/$name/repos/$repo"
dialog --title "LARBS Installation" --infobox "Installing \`$(basename "$1")\` ($n of $total) via \`git\` and \`make\`. $(basename "$1") $2" 5 70
sudo -u "$name" mkdir -p "$repodir"
sudo -u "$name" git clone --depth 1 "$1" "/home/$name/repos/$repo" >/dev/null 2>&1
cd "$repodir" || exit
make install >/dev/null 2>&1
cd /tmp || return ;}
pipinstall() { \
dialog --title "LARBS Installation" --infobox "Installing the Python package \`$1\` ($n of $total). $1 $2" 5 70
command -v pip || pacman -S --noconfirm --needed python-pip >/dev/null 2>&1
yes | pip install "$1"
}
installationloop() { \
([ -f "$progsfile" ] && cp "$progsfile" /tmp/progs.csv) || curl -Ls "$progsfile" | sed '/^#/d' > /tmp/progs.csv
total=$(wc -l < /tmp/progs.csv)
while IFS=, read -r tag program comment; do
n=$((n+1))
echo "$comment" | grep "^\".*\"$" >/dev/null 2>&1 && comment="$(echo "$comment" | sed "s/\(^\"\|\"$\)//g")"
case "$tag" in
"") maininstall "$program" "$comment" ;;
"G") gitmakeinstall "$program" "$comment" ;;
"P") pipinstall "$program" "$comment" ;;
esac
done < /tmp/progs.csv ;}
putgitrepo() { # Downlods a gitrepo $1 and places the files in $2 only overwriting conflicts
[ -z "$3" ] && branch="master" || branch="$repobranch"
dialog --infobox "Downloading and installing config files..." 4 60
dir=$(mktemp -d)
[ ! -d "$2" ] && mkdir -p "$2" && chown -R "$name:wheel" "$2"
chown -R "$name:wheel" "$dir"
sudo -u "$name" git clone -b "$branch" --depth 1 "$1" "$dir/gitrepo" >/dev/null 2>&1 &&
sudo -u "$name" cp -rfT "$dir/gitrepo" "$2"
}
serviceinit() { for service in "$@"; do
dialog --infobox "Enabling \"$service\"..." 4 40
ln -s "/etc/sv/$service" /var/service/
sv start "$service"
done ;}
systembeepoff() { dialog --infobox "Getting rid of that retarded error beep sound..." 10 50
rmmod pcspkr
echo "blacklist pcspkr" > /etc/modprobe.d/nobeep.conf ;}
finalize(){ \
dialog --infobox "Preparing welcome message..." 4 50
dialog --title "All done!" --msgbox "Congrats! Provided there were no hidden errors, the script completed successfully and all the programs and configuration files should be in place.\\n\\nTo run the new graphical environment, log out and log back in as your new user, then run the command \"startx\" to start the graphical environment (it will start automatically in tty1).\\n\\n.t Luke" 12 80
}
### THE ACTUAL SCRIPT ###
### This is how everything happens in an intuitive format and order.
# Check if user is root on Arch distro. Install dialog.
xbps-install -Syu dialog
# Welcome user.
welcomemsg || error "User exited."
# Get and verify username and password.
getuser || error "User exited."
# Last chance for user to back out before install.
preinstallmsg || error "User exited."
### The rest of the script requires no user input.
dialog --title "LARBS Installation" --infobox "Installing \`basedevel\` and \`git\` for installing other software." 5 70
xbps-install -y curl base-devel git >/dev/null 2>&1
# The command that does all the installing. Reads the progs.csv file and
# installs each needed program the way required. Be sure to run this only after
# the user has been created and has priviledges to run sudo without a password
# and all build dependencies are installed.
installationloop
# Install the dotfiles in the user's home directory
putgitrepo "$dotfilesrepo" "/home/$name" "$repobranch"
rm -f "/home/$name/README.md" "/home/$name/LICENSE"
# Enable services here.
serviceinit alsa wpa_supplicant dbus
# Most important command! Get rid of the beep!
systembeepoff
# Last message! Install complete!
finalize
clear

View File

@ -1,69 +0,0 @@
#TAG,NAME IN REPO (or git url),PURPOSE (should be a verb phrase to sound right while installing)
,xorg-minimal,"is the graphical server."
,xorg-fonts,"is a font package."
,libX11-devel,"is required for the compilation of some programs."
,libXft-devel,"is required for the compilation of some programs."
,webkit2gtk,"is the backend for the browser."
,webkit2gtk-devel,"is required for the compilation of some programs."
,gcr-devel,"is required for the compilation of some programs."
,fontconfig-devel,"is required for the compilation of some programs."
,xwininfo,"allows querying information about windows."
,xinit,"starts the graphical server."
,font-inconsolata-otf,"is the monospace font of LARBS."
,font-libertine-otf,"provides the sans and serif fonts for LARBS."
,font-awesome,"provides special characters used in the status bar and elsewhere."
,lf,"is an extensive terminal file manager that everyone likes."
,arandr,"is a UI for screen adjustment."
,calcurse,"is a lightweight terminal-based calendar."
,xcompmgr,"is for transparency and removing screen-tearing."
,xprop,"is a tool for detecting window properties."
,libnotify,"allows desktop notifications."
,dbus,"facilitates inter-process communication."
,dunst,"is a suckless notification system."
,sxiv,"is a minimalist image viewer."
,xwallpaper,"sets the wallpaper."
,ffmpeg,"can record and splice video and audio on the command line."
,neovim,"an tidier vim with some useful features"
,mpd,"is a lightweight music daemon."
,mpc,"is a terminal interface for mpd."
,mpv,"is the patrician's choice video player."
,ncmpcpp,"a ncurses interface for music with multiple formats and a powerful tag editor."
,newsboat,"is a terminal RSS client."
,noto-fonts-emoji,"is a package that gives the system unicode symbols and emojis used in the status bar and elsewhere."
,font-symbola,"provides unicode and emoji symbols."
,alsa-utils,"is a package of audio utilities."
,sc-im,"is an Excel-like terminal spreadsheet manager."
,htop,"provides system usage information and displays processes."
,maim,"can take quick screenshots at your request."
,socat,"is a socket utility."
,unclutter-xfixes,"hides an inactive mouse."
,unrar,"extracts rar's."
,unzip,"unzips zips."
,w3m,"is a terminal browser which can also view images."
,xcape,"gives the special escape/super mappings of LARBS."
,xclip,"allows for copying and pasting from the command line."
,xdotool,"provides window action utilities on the command line."
,xdpyinfo,"aids with resolution determination and screen recording."
,youtube-dl,"can download any YouTube video (or playlist or channel) when given the link."
,zathura,"is a pdf viewer with vim-like bindings."
,zathura-djvu,"gives zathura the ability to read .djvu files."
,zathura-pdf-mupdf,"allows mupdf pdf compatibility in zathura."
,poppler,"manipulates .pdfs and gives .pdf previews and other .pdf functions."
,mediainfo,"shows audio and video information and is used by vifm as well."
,atool,"manages and gives information about archives."
,fzf,"is a fuzzy finder tool."
,highlight,"can highlight code output."
,gst-plugins-good1,"allows video streaming including YouTube videos."
,gst-libav,"allows video streaming including YouTube videos."
,sxhkd,"binds keys in and outside of dwm."
,setxkbmap,"allows LARBS's unique keyboard bindings."
,xmodmap,"allows LARBS's unique keyboard bindings."
,xsetroot,"sets status bar and other X properies."
,simple-mtpfs,"enables the mounting of cell phones."
,xset,"allows speeding up the X rate."
G,https://github.com/lukesmithxyz/dmenu.git,"runs commands and provides a UI for selection."
G,https://github.com/lukesmithxyz/st.git,"is my custom build of suckless's terminal emulator."
,tabbed,"allows tabbing other programs like the terminal or the browser."
G,https://github.com/lukesmithxyz/surf.git,"is the suckless web browser."
G,https://github.com/lukesmithxyz/dwm.git,"is the window manager."
,ts,"queues commands or files for download."
1 #TAG NAME IN REPO (or git url) PURPOSE (should be a verb phrase to sound right while installing)
2 xorg-minimal is the graphical server.
3 xorg-fonts is a font package.
4 libX11-devel is required for the compilation of some programs.
5 libXft-devel is required for the compilation of some programs.
6 webkit2gtk is the backend for the browser.
7 webkit2gtk-devel is required for the compilation of some programs.
8 gcr-devel is required for the compilation of some programs.
9 fontconfig-devel is required for the compilation of some programs.
10 xwininfo allows querying information about windows.
11 xinit starts the graphical server.
12 font-inconsolata-otf is the monospace font of LARBS.
13 font-libertine-otf provides the sans and serif fonts for LARBS.
14 font-awesome provides special characters used in the status bar and elsewhere.
15 lf is an extensive terminal file manager that everyone likes.
16 arandr is a UI for screen adjustment.
17 calcurse is a lightweight terminal-based calendar.
18 xcompmgr is for transparency and removing screen-tearing.
19 xprop is a tool for detecting window properties.
20 libnotify allows desktop notifications.
21 dbus facilitates inter-process communication.
22 dunst is a suckless notification system.
23 sxiv is a minimalist image viewer.
24 xwallpaper sets the wallpaper.
25 ffmpeg can record and splice video and audio on the command line.
26 neovim an tidier vim with some useful features
27 mpd is a lightweight music daemon.
28 mpc is a terminal interface for mpd.
29 mpv is the patrician's choice video player.
30 ncmpcpp a ncurses interface for music with multiple formats and a powerful tag editor.
31 newsboat is a terminal RSS client.
32 noto-fonts-emoji is a package that gives the system unicode symbols and emojis used in the status bar and elsewhere.
33 font-symbola provides unicode and emoji symbols.
34 alsa-utils is a package of audio utilities.
35 sc-im is an Excel-like terminal spreadsheet manager.
36 htop provides system usage information and displays processes.
37 maim can take quick screenshots at your request.
38 socat is a socket utility.
39 unclutter-xfixes hides an inactive mouse.
40 unrar extracts rar's.
41 unzip unzips zips.
42 w3m is a terminal browser which can also view images.
43 xcape gives the special escape/super mappings of LARBS.
44 xclip allows for copying and pasting from the command line.
45 xdotool provides window action utilities on the command line.
46 xdpyinfo aids with resolution determination and screen recording.
47 youtube-dl can download any YouTube video (or playlist or channel) when given the link.
48 zathura is a pdf viewer with vim-like bindings.
49 zathura-djvu gives zathura the ability to read .djvu files.
50 zathura-pdf-mupdf allows mupdf pdf compatibility in zathura.
51 poppler manipulates .pdfs and gives .pdf previews and other .pdf functions.
52 mediainfo shows audio and video information and is used by vifm as well.
53 atool manages and gives information about archives.
54 fzf is a fuzzy finder tool.
55 highlight can highlight code output.
56 gst-plugins-good1 allows video streaming including YouTube videos.
57 gst-libav allows video streaming including YouTube videos.
58 sxhkd binds keys in and outside of dwm.
59 setxkbmap allows LARBS's unique keyboard bindings.
60 xmodmap allows LARBS's unique keyboard bindings.
61 xsetroot sets status bar and other X properies.
62 simple-mtpfs enables the mounting of cell phones.
63 xset allows speeding up the X rate.
64 G https://github.com/lukesmithxyz/dmenu.git runs commands and provides a UI for selection.
65 G https://github.com/lukesmithxyz/st.git is my custom build of suckless's terminal emulator.
66 tabbed allows tabbing other programs like the terminal or the browser.
67 G https://github.com/lukesmithxyz/surf.git is the suckless web browser.
68 G https://github.com/lukesmithxyz/dwm.git is the window manager.
69 ts queues commands or files for download.